    TITLE		"Mirco-OPAZ"
    SUBTITLE	"v1.13"
    RADIX		HEX
    LIST		p=16c77
    INCLUDE		p16c77.inc

;
; == Notes ==
;
; Version DEBUG non fonctionnelle !
;

;
; Dclaration des variables utiles
;

Compteur16	equ	0x20		; Compteur pour le multiplexeur 4067 16 ports.
Compteur8	equ	0x21		; Compteur pour le multiplexeur 4051 8 ports.
TableAN16	equ	0x22		; Table des valeurs du multiplexeur 4067 16 ports.
TableAN8	equ	0x32		; Table des valeurs du multiplexeur 4051 8 ports.
resAN		equ	0x3A		; Resultat de la convertion AN.
resRx		equ	0x3B		; Rsultat de la rception USART
Save_W	equ	0x3C		; Sauvegarde du registre W
Save_Status	equ	0x3D		; Sauvegarde du registre Status
Save_PcLath	equ	0x3E		; Sauvegarde du registre PcLath
Save_FSR	equ	0x3F		; Sauvegarde du registre FSR
vDelay	equ	0x40		; Variable pour le dlais d'attente conversion AN
BasculeAN8	equ	0x41		; Table bascule pour les interrupteurs
valBascule	equ	0x49		; Valeur de la bascule pour la transmission a venir


	org	0x000			; Reset Vector.
	goto	Start





	; ====================
	; == Initialisation ==
	; ====================
	
Start					; Entre du programme.
	bcf	Status, RP1		; RP1 reste inchang tout au long du programme.
	bcf	Status, RP0		; Selectionne le Bank 0.
	clrf	PortA			; Efface le Port A.
	clrf	PortB			; Efface le Port B.
	clrf	PortC			; Efface le Port C.
	clrf	PortD			; Efface le Port D.

	bsf	Status, RP0		; Slectionne le Bank 1.
	movlw	0x07			; Valeur 0000 0111
	movwf	TrisA			; Mode IN pour RA0-2
	clrf	TrisB			; Port B en Out: MC14067: Multiplexeur 16x potars
	movlw	0x80			; Valeur 1000 0000
	movwf	TrisC			; Port C en Out (sauf pour Rx de USART): 74HC4051: Mutilplexeur 8x boutons
	clrf	TrisD			; Port D en Out: 74HC259: Gestion des leds

	call	InitLeds		; Initialisation des les leds a OFF
	;call	InitAN			; Paramtrage du module de conversion
	call	InitRxTx		; Paramtrage pour le module de trasmission.
	;call	AN16First		; Chargement des valeurs initiales des controleurs
	;call	AN8First		; Chargement des valeurs initiales des controleurs

	bcf	Status,	RP0	; Selectionne le Bank 0.
	clrf 	Compteur16		; Met le compteur16 a 0.
	clrf 	Compteur8		; Met le compteur8 a 0.
	clrf	valBascule		;

	bcf	Status,	IRP	; Bank 0-1 slectionn pour l'adressage indirect.
	movlw	0x02			; Utilis uniquement pour l'instruction addwf PCL, F
	movwf	PCLATH		;  qui ne sont pas dans le bon segement de mmoire



	; =======================
	; == Boucle Principale ==
	; =======================

MainLoop


	bcf	Status,	RP0	; Selectionne le Bank 0.
	btfsc	PIR1,	RCIF		; Si le buffer est plein, on appelle la fonction
	call	MidiReEmit
	call	ReSetLED1		; !!! DEBUG !!!
	call	ReSetLED2		; !!! DEBUG !!!
	call	ReSetLED3		; !!! DEBUG !!!
	goto	MainLoop



LoopCompteur16
	movf	Compteur16, W	; Met le nombre du compteur16 dans 
	movwf	PortB			;  le Port B pour les multiplexeurs.
	call	AN16Start		; Appel de la routine de traitement.
	bcf	Status,	RP0	; Selectionne le Bank 0. (banks changs par les fonctions)
	incf	Compteur16, F	; Increment de Compteur.
	movf	Compteur16, W	; 
	sublw	0x0F			; ( 15 - Compteur ) -> W
	btfss	Status,	Z	; Si le resultat vaut zero, alors on saute le goto et on reinitialise le Compteur.
	goto	LoopCompteur16	; Sinon, on boucle.

LoopCompteur8
	;movlw	b'11111000'	; Remplacement d'un movf  Compteur8, W & movwf PortC
	;andwf	PortC		;   cause d'un conflit PortC et RXTX
	;movf	Compteur8, W	;  Efface les bit 0-2 du PortC
	;iorwf	PortC		;  Copie les bit 0-3 du compteur sue le PortC

	movf	Compteur8, W	;
	movwf	PortC			;

	call	AN8Start		; Appel de la routine de traitement.
	bcf	Status,	RP0	; Selectionne le Bank 0. (banks changs par les fonctions)
	incf	Compteur8, F	; Increment de Compteur.
	movf	Compteur8, W	; 
	sublw	0x05			; ( 5 - Compteur ) -> W  Car 5? bouttons !!! DEBUG !!!
	btfss	Status, Z		; Si le resultat vaut zero, alors on saute le goto et on reinitialise le Compteur.
	goto	LoopCompteur8	; Sinon, on boucle.

	clrf	Compteur16
	clrf	Compteur8
	
	bcf	Status,	RP0	; Selectionne le Bank 0.
	btfsc	PIR1,	RCIF		; Si le buffer est plein, on appelle la fonction
	call	MidiReEmit

	call	ReSetLED1		; !!! DEBUG !!!
	call	ReSetLED5		; !!! DEBUG !!!

	goto	MainLoop



	; ===========================
	; == Routines du Programme ==
	; ===========================


	; ------------
	; -- InitAN --
	; ------------

InitAN
	; Initalisation du module de convertion AN.
	bcf	Status,	RP0	; Slectionne le Bank 0.
	movlw	0xC0			; 1100 0000
	movwf	ADCON0		; Config canal + Freq osc

	bsf	Status,	RP0	; Slectionne le Bank 1.
	movlw	0x04			; 0000 0100
	movwf	ADCON1		; Pour RA0 en mode analogique et RA2 en mode numrique et Vref = Vdd

	; !!! Test en mode manuel... bsf bcf !!!


	return		




	; --------------
	; -- InitRxTx --
	; --------------

InitRxTx
	bsf	Status,	RP0	; Slectionne le Bank 1
	movlw	0x27			; Coefficient pour le 'baud rate generator'
					;  Baud Rate = Fosc / (16*(X+1)) 
					; Pour la norme MIDI avec un Oscillateur a 20.000 MHz
					;  31250 = 20000000 / (16*(39+1))
					;  Coef de 39, soit 0x27
	movwf	SPBRG			; Enregistre la configuration.

	bsf	TXSTA,	BRGH	; Mode High Speed.
	bcf	TXSTA,	SYNC	; Mode Asynchrone.
	bcf	TXSTA,	TX9	; On dsactive la prise en compte du 9eme bit en mission.

	bcf	Status,	RP0	; Slectionne le Bank 0.
	bcf	RCSTA,	RX9	; On dsactive la prise en compte du 9eme bit en rception.
	bsf	RCSTA,	SPEN	; Active le port serie USART pour les pins RX/TX. (Serial Port Enable)
	bsf	RCSTA,	CREN	; Active la rception

	return




	; --------------
	; -- InitLEDS --
	; --------------

InitLEDS
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x00			; Led 0 - Off
	movwf	PortD			;
	movlw	0x01			; Led 1 - Off
	movwf	PortD			;
	movlw	0x02			; Led 2 - Off
	movwf	PortD			;
	movlw	0x03			; Led 3 - Off
	movwf	PortD			;
	movlw	0x04			; Led 4 - Off
	movwf	PortD			;
	movlw	0x05			; Led 5 - Off
	movwf	PortD			;
	movlw	0x06			; Led 6 - Off
	movwf	PortD			;
	movlw	0x07			; Led 7 - Off
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;

	return




	; ---------------
	; -- AN16First --
	; ---------------

AN16First
	bcf	Status,	RP0	; Selectionne le Bank 0.
	clrf	Compteur16

	movlw	TableAN16		; pointeurFSR = adresseTable
	movwf	FSR			;  Adresse TableAN16(0) dans FSR.

	; !!! Inutile !!!
	;bcf	ADCON0,	CHS0	; Channel 0.
	bsf	ADCON0, ADON	; Active le module de conversion (bit 0).

AN16First_Loop
	movf	Compteur16, W	; Met le nombre du compteur16 dans 
	movwf	PortB			;  le Port B pour les multiplexeurs.

	clrf	ADRES			; Efface l'ancienne valeur d'acquisition.
	call	delayAN		; Laisse en temps ncessaire pour le sampling.
	bsf	ADCON0,	GO	; Commence la convertion en placant le bit
					;  GO de ADCON0 a 1.
AN16First_Wait
	btfsc	ADCON0, GO		; La conversion AN est finie si le bit GO de ADCON0 est mise a 0 par le processeur.
	goto	AN16First_Wait	; Le bit est a 1 alors on boucle.

	movf	ADRES,	W	; Sauvegarde du rsultat 
	movwf	INDF			;  la Table(Compteur).

	incf	FSR,	F		; Incrmente le pointeur de la TableAN16
	incf	Compteur16, F	; Increment de Compteur.

	movf	Compteur16, W	; 
	sublw	0x0F			; Quitte si on est arriv au 16me cannal.
	btfss	Status,	Z	;
	goto	AN16First_Loop	; Sinon, on boucle.

	bcf	ADCON0, ADON	; Desactive le module de conversion (bit 0).
	return




	; --------------
	; -- AN8First --
	; --------------

AN8First
	bcf	Status,	RP0	; Selectionne le Bank 0.
	clrf	Compteur8

	movlw	TableAN8		; pointeurFSR = adresseTable
	movwf	FSR			;  Adresse TableAN16(0) dans FSR.

AN8First_Loop
	;movlw	b'11111000'	; Remplacement d'un movf  Compteur8, W & movwf PortC
	;andwf	PortC		;   cause d'un conflit PortC et RXTX
	;movf	Compteur8, W	;  Efface les bit 0-2 du PortC
	;iorwf	PortC		;  Copie les bit 0-3 du compteur sue le PortC

	; !!! DEBUG !!!
	movf	Compteur8, W	;
	movwf	PortC			; Multiplexeur boutons: 4051

	btfsc	PortA,	2	; RA2
        goto    AN8First_On	;

AN8First_Off
	movlw	0x00			; Valeur OFF pour le controleur
	goto	AN8First_Suite

AN8First_On
	movlw	0x01			; Valeur OFF pour le controleur

AN8First_Suite
	movwf	INDF			;  la Table(Compteur).

	incf	FSR,	F		; Incrmente le pointeur de la TableAN8
	incf	Compteur8, F	; Increment de Compteur.

	movf	Compteur8, W	; 
	sublw	0x05			; Si on arrive au 6me bouton, on quitte
	btfss	Status,	Z	; 
	goto	AN8First_Loop	; Sinon, on boucle.

	return




	; ----------------
	; -- MidiReEmit --
	; ----------------

MidiReEmit
	call	SetLED1		; !!! DEBUG !!!
	call	SetLED4		; !!! DEBUG !!!

	bcf 	Status, RP0		; Selectionne le Bank 0.

	btfsc	RCSTA,	FERR
	goto	ErrorRecptionFERR

	btfsc	RCSTA,	OERR
	goto	ErrorRecptionOERR

	;movlw	06h		; Mask pour les bits FERR et OERR
	;andwf	RCSTA, W    ;  pour le registre RCSTA
	;btfss	STATUS, Z   ; Regarde si il y a des erreurs
	;goto	ErrorRecption	; Erreur dans la rception, on quitte.

;!!! DEBUG : Vrifier si RCIE de RCIF est bien effac a la lecture de RCREG !!!
	movf	RCREG, W          ; On sauvegarde le registre de l'USART dans
	movwf	resRx			;  ResRx.

	clrf	RCREG

	bsf 	Status, RP0		; Selectionne le Bank 1.
	bsf	TXSTA, 	TXEN	; Active la Transmission.

	; Transmission 
	bcf	Status, RP0		; Selectionne le Bank 0.

	; !!! DEBUG !!!
	movlw	0xB0
	movwf	TXREG

	;movf	resRx, W		; 
	;movwf	TXREG		; Place la valeur dans le registre de transmission, et commence la convertion.
	bsf	Status, RP0		; Selectionne le Bank 1.
MidiReEmit_Wait
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	MidiReEmit_Wait	; Sort de la boucle quand TSR est vide (TSR = 1).

	bcf	TXSTA, 	TXEN	; Dsactive la Transmission : Fin de Transmission.

MidiReEmitEnd
	return

ErrorRecptionFERR
	call	SetLED2		; !!! DEBUG !!!
	goto	ErrorRecption	;

ErrorRecptionOERR
	call	SetLED3		; !!! DEBUG !!!
	goto	ErrorRecption	;

ErrorRecption
	call	SetLED5		; !!! DEBUG !!!
	bcf	Status,	RP0	; Slectionne le Bank 0.
	bcf	RCSTA,CREN		; Clear receiver status
	bsf	RCSTA,CREN		; Et reactive la rception
	goto	MidiReEmitEnd




	; ---------------
	; -- AN16Start --
	; ---------------

AN16Start
	bcf	Status,	RP0	; Selectionne le Bank 0.

	; !!! Obtimisable car on n'utilise que le channel 0 !!!
	;bcf	ADCON0,	CHS0	; Channel 0.

	bsf	ADCON0, ADON	; Active le module de conversion (bit 0).
	clrf	ADRES			; Efface l'ancienne valeur d'acquisition.
	call	delayAN		; Laisse en temps ncessaire pour le sampling.
	bsf	ADCON0,	GO	; Commence la convertion en placant le bit
					;  GO de ADCON0 a 1.
AN16Wait
	btfsc	ADCON0, GO		; La conversion AN est finie si le bit GO de ADCON0 est mise a 0 par le processeur.
	goto	AN16Wait		; Le bit est a 1 alors on boucle.

	; La conversion est ici termine.
	movf	ADRES,	W	; Sauvegarde du rsultat 
	movwf	resAN			;  dans ResAN
	movlw	TableAN16		; pointeurFSR = adresseTable + Compteur.
	addwf	Compteur16, W	;  
	movwf	FSR			;  Adresse Table(i) dans FSR.

	movf	resAN,	W	; 
	subwf	INDF,	W		; ( valeurTable - valeurActuelle ) -> W 
					; INDF = valeur du pointeur FSR.	

	; On teste tout d'abord l'glit.
	btfsc	Status, Z		; Cas d'galit, valeur inchangee.
	goto	AN16NoTransmit	;  On quitte vers noTransmit.

	; Traitement des cas de Non-Egalite:
	; W contient a prsent la valeur de la soustraction
	btfss	Status,	C	; On teste si la valeur est negative.
	goto	AN16Negative	;  On continue  negativeComp si oui.

AN16Positive			; Traitement des cas Positifs:
					; Pour viter la transmission intensive lie a l'ocsillation permanente du dernier
					;  bit, on effectue un soustration de 2, qui qui garantie le changement rel de valeur.
					;
					; On restrain alors la precsion a 7 bits, au lieu des 8 bits initiaux.
					; Sans importance car le midi traite du 7 bits. (valeur de 0-127)
	sublw	0x01			; ( 1 - W ) -> W'  // 00 + 1 = 0x01
	btfss	Status, C		;
	goto	AN16Transmit	; Si le resultat est gal a zro ou superieur, alors on transmet la nouvelle valeur.
	goto	AN16NoTransmit	; Dans la cas contraire, (valeur negative) on ne transmet rien.

AN16Negative
	; Ici, on a un W 'ngatif' donc du genre 0xFF.
	sublw	0xFE			; ( 254 - W ) -> W' // FF - 1 = 0xFE
	btfss	Status, C		;
	goto	AN16NoTransmit	; 

AN16Transmit
	movf	resAN,	W	; Sauvegarde du rsultat dans 
	movwf	INDF			;  la Table(Compteur).
	sublw	0xFF			; Putain de connerie de potar invers !
	movwf	resAN			;  Conversion de valeur: FF -> 00
	bcf	Status,	C	; Decalage d'un bit vers la droite
	rrf	resAN,	F	; ce qui ramne la precision a 7 bits, soit 127.
	bcf	ADCON0, ADON	; Desactive le module de conversion (bit 0).
	call    Tx16Start		; Transmission via RS232.

AN16NoTransmit
	bcf	ADCON0, ADON	; Desactive le module de conversion (bit 0).
	return




	; --------------
	; -- AN8Start --
	; --------------
AN8Start
	; Fonction de dtection d'un changement d'tat des touches.
	bcf	Status,	RP0	; Selectionne le Bank 0.
	btfsc	PortA,	2	; Correspond a la pin 4 (RA2)
        goto    AN8On		; 

AN8Off
	movlw	TableAN8		; pointeurFSR = adresseTableAN8 + valeurCompteur.
	addwf	Compteur8, W	;  
	movwf	FSR			;  Adresse TableAN8(Compteur8) dans FSR.

	btfss	INDF, 0
	return			; Pas de changement, on se casse (No Transmit)

	bcf	INDF,	0		; Sauvegarde du rsultat dans la TableAN8(Compteur8).
	; Relachement de la touche
	; call	...
	return

AN8On
	movlw	TableAN8		; pointeurFSR = adresseTableAN8 + valeurCompteur.
	addwf	Compteur8, W	;  
	movwf	FSR			;  Adresse TableAN8(Compteur8) dans FSR.

	btfsc	INDF,	0		; Etat prcdent
	return			; Pas de changement, on se casse (No Transmit)

	bsf	INDF,	0		; Sauvegarde du rsultat dans la TableAN8(Compteur8).
	; Pression sur la touche
	;call    Bascule		;
	return




	; -------------
	; -- delayAN --
	; -------------

delayAN
	bcf	Status, RP0		; Selectionne le Bank 0.

	; !!! Tenter de diminuer un peu la valeur + test sur la vitesse avec potar
	movlw	0x20			; 10S de delay calcul pour un Pic a 20MHz.
	movwf	vDelay		;
delayLoop
	decfsz	vDelay,F    ; Test et dcrementation.
	goto	delayLoop		; Boucle tant que l'on est pas a zero.
	return




	; -------------
	; -- Bascule --
	; -------------
Bascule
	movlw	BasculeAN8		; pointeurFSR = adresseTableAN8 + valeurCompteur.
	addwf	Compteur8, W	;  
	movwf	FSR			;  Adresse TableAN8(Compteur8) dans FSR.

	btfss	INDF, 	0
	goto	BasculeSet

BasculeReSet
	; La bascule tait a 1, on la met  0.
	movlw	0x00			;
	movwf	INDF			;
	;bcf	INDF,	0		;

	movf	Compteur8, W	;
	;call	TranslateNum8
	;call	TranslateNum8Led
	movwf	PortD			;
	movlw	0x1F			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;

	movlw	0x00			;
	movwf	valBascule		;
	call	Tx8Start
	return

BasculeSet
	; La bascule tait a 0, on la met  1.
	movlw	0x01			;
	movwf	INDF			;
	;bsf	INDF,	0		;

	movf	Compteur8, W	;
	;call	TranslateNum8
	;call	TranslateNum8Led
	addlw	0x08			; Ajoute une valeur de dcalage pour On
	movwf	PortD			;
	movlw	0x1F			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;

	movlw	0x7F			;
	movwf	valBascule		;
	call	Tx8Start
	return




	; ---------------
	; -- Tx16Start --
	; ---------------

Tx16Start
	bsf 	Status, RP0		; Selectionne le Bank 1.
	bsf	TXSTA, 	TXEN	; Active la Transmission.

	; Transmission du header: Control Change
	bcf	Status, RP0		; Selectionne le Bank 0.
	movlw	0xB0			; On transmet la valeur 1011 0000 : Changement de controleur sur Canal Midi 1.
	movwf	TXREG			; Place la valeur dans le registre de transmission, et commence la convertion.
	bsf	Status, RP0		; Selectionne le Bank 1.
Tx16Wait0
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	Tx16Wait0		; Sort de la boucle quand TSR est vide (TSR = 1).

	; Transmission du numero du controleur.
	bcf	Status, RP0		; Selectionne le Bank 0.
	movf	Compteur16, W	; On transmet la valeur du compteur.
        call    TranslateNum16          ; Appel de la fct de rordonnancement.
	movwf	TXREG			; Place la valeur dans le registre de transmission, et commence la convertion.
	bsf	Status, RP0		; Selectionne le Bank 1.
Tx16Wait1
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	Tx16Wait1		; Sort de la boucle quand TSR est vide (TSR = 1).


	; Transmission de la valeur du controleur.
	bcf	Status, RP0		; Selectionne le Bank 0.
	movf	resAN,	W	; On transmet la valeur de la conversion AN.
	movwf	TXREG			; Place la valeur dans le registre de transmission, et commence la convertion.
	bsf	Status, RP0		; Selectionne le Bank 1.
Tx16Wait2
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	Tx16Wait2		; Sort de la boucle quand TSR est vide (TSR = 1).

	bsf	TXSTA, 	TXEN	; Dsactive la Transmission : Fin de Transmission
	return




	; --------------
	; -- Tx8Start --
	; --------------

Tx8Start
	bsf 	Status, RP0		; Selectionne le Bank 1.
	bsf	TXSTA, 	TXEN	; Active la Transmission.

	; Transmission du header: Control Change
	bcf	Status, RP0		; Selectionne le Bank 0.
	movlw	0xB0			; On transmet la valeur 1011 0000 : Changement de controleur sur Canal Midi 1.
	movwf	TXREG			; Place la valeur dans le registre de transmission, et commence la convertion.
	bsf	Status, RP0		; Selectionne le Bank 1.

Tx8Wait0
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	Tx8Wait0		; Sort de la boucle quand TSR est vide (TSR = 1).


	; Transmission du numero du controleur.
	bcf	Status, RP0		; Selectionne le Bank 0.
	movf	Compteur8, W	; On transmet la valeur du compteur.
	call	TranslateNum8	; Appel de la fct de rordonnancement.
	addlw	0x10			; Ajoute 16 pour le dcalage des controleurs analogiques	
	movwf	TXREG			; Place la valeur dans le registre de transmission, et commence la conversion.
	bsf	Status, RP0		; Selectionne le Bank 1.

Tx8Wait1
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	Tx8Wait1		; Sort de la boucle quand TSR est vide (TSR = 1).

	; Transmission On / Off de la bascule 
	bcf	Status, RP0		; Selectionne le Bank 0.

	movf	valBascule, W	;
	movwf	TXREG			; Place la valeur dans le registre de transmission, et commence la convertion.
	bsf	Status, RP0		; Selectionne le Bank 1.

Tx8Wait2
	btfss	TXSTA,	TRMT	; Boucle d'attente du vidage du registre TSR.
	goto	Tx8Wait2		; Sort de la boucle quand TSR est vide (TSR = 1).

	bsf	TXSTA, 	TXEN	; Dsactive la Transmission : Fin de Transmission
	return






	; -------------
	; -- SetLED1 --
	; -------------

SetLED1
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x0C			; Led 0x00
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; -------------
	; -- SetLED2 --
	; -------------

SetLED2
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x0B			; Led 0x01 
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; -------------
	; -- SetLED3 --
	; -------------

SetLED3
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x08			; Led 0x02
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; -------------
	; -- SetLED4 --
	; -------------

SetLED4
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x09			; Led 0x03
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; -------------
	; -- SetLED5 --
	; -------------

SetLED5
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x0A			; Led 0x04
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; --------------------------
	; -- SetLED6 (OUT) Pin 10 --
	; --------------------------

SetLED6
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x0D			; Led 0x05
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------------------
	; -- SetLED7 (OUT)  Pin 11 --
	; ---------------------------

SetLED7
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x0E			; Led 0x06
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------------------
	; -- SetLED8 (OUT)  Pin 12 --
	; ---------------------------

SetLED8
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x0F			; Led 0x07
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------
	; -- ReSetLED1 --
	; ---------------

ReSetLED1
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x04			; Led 0x00
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------
	; -- ReSetLED2 --
	; ---------------

ReSetLED2
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x03			; Led 0x01 
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------
	; -- ReSetLED3 --
	; ---------------

ReSetLED3
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x00			; Led 0x02
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------
	; -- ReSetLED4 --
	; ---------------

ReSetLED4
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x01			; Led 0x03
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ---------------
	; -- ReSetLED5 --
	; ---------------

ReSetLED5
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x02			; Led 0x04
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; ----------------------------
	; -- ReSetLED6 (OUT) Pin 10 --
	; ----------------------------

ReSetLED6
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x05			; Led 0x05
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; -----------------------------
	; -- ReSetLED7 (OUT)  Pin 11 --
	; -----------------------------

ReSetLED7
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x06			; Led 0x06
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return




	; -----------------------------
	; -- ReSetLED8 (OUT)  Pin 12 --
	; -----------------------------

ReSetLED8
	bcf	Status,	RP0	; Selectionne le Bank 0.
	movlw	0x07			; Led 0x07
	movwf	PortD			;
	movlw	0x10			; Passe en mode Mmory (Qn-1)
	movwf	PortD			;
	return





	; *******************
	; ** Mmoire 0x220 **
	; *******************
	org	0x220



	; -------------------------
	; -- TranslateNum8toNote --
	; -------------------------

TranslateNum8toNote
	; Fonction de Convertion d'un numro en un autre.
	; Prend W en entre, et sort le numro correspondant dans W.
	addwf 	PCL,	F		; Avance le PC de W
        retlw	0x35			; (3) - F-3 - Bouton 1
        retlw	0x34			; (2) - E-3 - Bouton 2
        retlw	0x32			; (1) - D-3 - Bouton 3
        retlw	0x37			; (4) - G-3 - Bouton 4
        retlw	0x30			; (0) - C-3 - Bouton 5
        retlw	0x39			; (5) - A-3 - Libre 6
        retlw	0x3B			; (6) - B-3 - Libre 7
        retlw	0x3C			; (7) - C-4 - Libre 8




TranslateNum8
	; Fonction de Convertion d'un numro en un autre.
	; Prend W en entre, et sort le numro correspondant dans W.
	addwf 	PCL,	F		; Avance le PC de W
        retlw	0x03			; Bouton 1
        retlw	0x02			; Bouton 2
        retlw	0x01			; Bouton 3
        retlw	0x04			; Bouton 4
        retlw	0x00			; Bouton 5
        retlw	0x05			; Libre 6
        retlw	0x06			; Libre 7
        retlw	0x07			; Libre 8




	; ----------------------
	; -- TranslateNum8Led --
	; ----------------------

TranslateNum8Led
	; Fonction de Convertion d'un numro en un autre.
	; Prend W en entre, et sort le numro correspondant dans W.
	addwf 	PCL,	F		;
        retlw	0x04			; Led 1
        retlw	0x03			; Led 2
        retlw	0x00			; Led 3
        retlw	0x01			; Led 4
        retlw	0x02			; Led 5
        retlw	0x05			; Out 6 
        retlw	0x06			; Out 7
        retlw	0x07			; Out 8




	; --------------------
	; -- TranslateNum16 --
	; --------------------

TranslateNum16
	; Fonction de Convertion d'un numro en un autre.
	; Prend W en entre, et sort le numro correspondant dans W.
	addwf 	PCL,	F		; Avance le PC de W
        retlw	0x04			; Potentiomtre 01 (L1C1)
        retlw	0x03			; Potentiomtre 02 (L1C2)
        retlw	0x01			; Potentiomtre 03 (L1C3)
        retlw	0x08			; Potentiomtre 04 (L1C4)
        retlw	0x06			; Potentiomtre 05 (L1C5)
        retlw	0x0D			; Potentiomtre 06 (L2C1)
        retlw	0x0B			; Potentiomtre 07 (L2C2)
        retlw	0x05			; Potentiomtre 08 (L2C3)
        retlw	0x0A			; Potentiomtre 09 (L2C4)
        retlw	0x00			; Potentiomtre 10 (L2C5)
        retlw	0x0C			; Potentiomtre 11 (L3C1)
        retlw	0x0E			; Potentiomtre 12 (L3C2)
        retlw	0x07			; Potentiomtre 13 (L3C3)
        retlw	0x09			; Potentiomtre 14 (L3C4)
        retlw	0x02			; Potentiomtre 15 (L3C5)
        retlw	0x0F			; Potentiomtre 16 (Libre)

	END
